
package sec06.exam01;
import java.text.DecimalFormat;

interface Shape
{
	public static final double PI = 3.1415;
	public abstract double Area();
	public abstract double Measurement();
	
	public abstract void ShowInfo();
} 

class Circle implements Shape
{
	private double radius;
	
	
	public Circle(double radius)
	{
		this.radius = radius;
	}
	@Override
	public double Area()
	{
		return Shape.PI * radius * radius;
	}
	@Override
	public double Measurement()
	{
		return ((2 * Shape.PI) * this.radius);
	}
	@Override
	public void ShowInfo()
	{
		System.out.println("원의 둘레 : " +new DecimalFormat("#.00").format(this.Measurement()));
		System.out.println("원의 넓이 : "+new DecimalFormat("#.00").format(this.Area()));
	}
}

class Triangle implements Shape
{
	private int side1;
	private int side2;
	private int side3;
	
	public Triangle(int side1, int side2, int side3)
	{
		this.side1 = side1;
		this.side2 = side2;
		this.side3 = side3;
	}
	@Override
	public double Area()
	{
		double s = this.Measurement()/2;
		
		double area = Math.sqrt(
				s*(s-this.side1)*(s-this.side2)*(s-this.side3)
				);
		
		return area;
	}
	@Override
	public double Measurement()
	{
		return (this.side1+this.side2+this.side3);
		
		
	}
	@Override
	public void ShowInfo()
	{
		System.out.println("삼각형의 둘레 : "+new DecimalFormat("#.00").format(this.Measurement()));
		System.out.println("삼각형의 넓이 : "+new DecimalFormat("#.00").format(this.Area()));
	}
}

class Rectangle implements Shape
{
	private int width;
	private int height;
	
	public Rectangle(int width, int height)
	{
		this.width = width;
		this.height = height;
	}
	@Override
	public double Area()
	{
		return (this.width * this.height);
	}
	@Override
	public double Measurement()
	{
		return 2 * (this.width + this.height);
	}
	@Override
	public void ShowInfo()
	{
		System.out.println("직사각형의 둘레 : "+new DecimalFormat("#.00").format(this.Measurement()));
		System.out.println("직사각형의 넓이 : "+new DecimalFormat("#.00").format(this.Area()));
	}
}

public class Quiz 
{
	public static void main(String[] args)
	{
		Shape c1 = new Circle(5);
		
		c1.ShowInfo();
		
		Shape c2 = new Rectangle(10,5);
		
		c2.ShowInfo();
		
		Shape c3 = new Triangle(10,10,10);
		
		c3.ShowInfo();
	}
}













